'use strict';

Object.defineProperty(exports, '__esModule', {
	value: true
});

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _get = function get(_x, _x2, _x3) { var _again = true; _function: while (_again) { var object = _x, property = _x2, receiver = _x3; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x = parent; _x2 = property; _x3 = receiver; _again = true; desc = parent = undefined; continue _function; } } else if ('value' in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactNative = require('react-native');

var React = require('react');

var SegmentedProgress = (function (_React$Component) {
	_inherits(SegmentedProgress, _React$Component);

	function SegmentedProgress(props) {
		_classCallCheck(this, SegmentedProgress);

		_get(Object.getPrototypeOf(SegmentedProgress.prototype), 'constructor', this).call(this, props);

		this.state = { style: this.getStyle() };
	}

	_createClass(SegmentedProgress, [{
		key: 'componentWillUpdate',
		value: function componentWillUpdate(nextProps, nextState) {
			// Check if the props updated, if yes change the style
			var propsToCheck = ['tintColor', 'segmentMargin'];
			for (var i = 0, len = propsToCheck.length; i < len; i++) {
				var object = propsToCheck[i];
				if (nextProps[object] != this.props[object]) {
					this.setState({ style: this.getStyle() });
					break;
				}
			}
		}
	}, {
		key: 'getStyle',
		value: function getStyle() {
			return _reactNative.StyleSheet.create({
				container: {
					flexDirection: 'row'
				},
				step: {
					flex: 1,
					margin: this.props.segmentMargin,
					backgroundColor: this.props.tintColor
				}
			});
		}
	}, {
		key: 'render',
		value: function render() {
			var stepComponents = [];
			for (var i = 0; i < props.numberOfSteps; i++) {
				var opacity = 0.5;
				if (i == props.activeStep) {
					opacity = 1.0;
				} else if (i < props.activeStep) {
					opacity = 0.8;
				}
				stepComponents.push(React.createElement(_reactNative.View, { key: i, style: [styles.step, { opacity: opacity }] }));
			}
			return React.createElement(
				_reactNative.View,
				{ style: [styles.container, props.style] },
				stepComponents
			);
		}
	}]);

	return SegmentedProgress;
})(React.Component);

SegmentedProgress.defaultProps = {
	tintColor: 'white',
	segmentMargin: 4
};

SegmentedProgress.propTypes = {
	numberOfSteps: _propTypes2['default'].number.isRequired,
	activeStep: _propTypes2['default'].number.isRequired,
	tintColor: _propTypes2['default'].string,
	segmentMargin: _propTypes2['default'].number
};

exports['default'] = SegmentedProgress;
module.exports = exports['default'];